#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
vector<vector<int>> a;
int main(){
    ios_base::sync_with_stdio(false); cin.tie(0);
    int n,m,g,a1,a2;
    cin >> n >> m >> g;
    a.resize(n);
    for (int i=0;i<m;i++){
        cin >> a1 >> a2;
        a[a1-1].push_back(a2-1);
        a[a2-1].push_back(a1-1);
    }
    cout << m-n+1 << ' ' << 1 << '\n';
}
